lappend serach_path ./
source scripts/set_sz.tcl
set mw_logic0_net VSS
set mw_logic1_net VDD
define_name_rules verilog -allowed "A-Z0-9_"

create_mw_lib CUBE_TOP -technology lib/tech.tf -mw_reference_library "CS202SZ CS202IO cube sb4 ptp" -open
# open_mw_lib CUBE_TOP
import_designs ./CUBE_TOP.vnet -format verilog -top CUBE_TOP
read_sdc ./CUBE_TOP.sdc
set_tlu_plus_files -max_tluplus ./lib/tlu_plus_mfe.worst \
  -min_tluplus ./lib/tlu_plus_mfe.best \
  -tech2itf_map ./lib/layer.map
derive_pg_connection -power_net {VDD} \
  -ground_net {VSS} -power_pin {VDD} -ground_pin {VSS}
derive_pg_connection -tie -power_net VDD -ground_net VSS
derive_pg_connection -power_net VDDBR -power_pin VDDBR
derive_pg_connection -tie -power_net VDDBR
derive_pg_connection -power_net VDDBC -power_pin VDDBC
derive_pg_connection -tie -power_net VDDBC

initialize_floorplan -control_type width_and_height \
  -core_width 1320 -core_height 1320 \
  -left_io2core 28 -right_io2core 28 \
  -top_io2core 28.6 -bottom_io2core 28
source ./scripts/iogen.tcl
source ./scripts/ioplace.tcl

derive_pg_connection -power_net VDDBR -power_pin VDDBR
derive_pg_connection -tie -power_net VDDBR 
derive_pg_connection -power_net VDDBC -power_pin VDDBC
derive_pg_connection -tie -power_net VDDBC
derive_pg_connection -power_net {VDD} \
  -ground_net {VSS} -power_pin {VDD} -ground_pin {VSS}
derive_pg_connection -tie -power_net VDD -ground_net VSS

insert_pad_filler -cell {IOCB2ESE4C0A1 IOCB2ESD4C0A1 IOCB2ES54C0A1 \
  IOCB2ES24C0A1 IOCB2ES14C0A1 IOCB2ESB4C0A1 IOCB2ESA4C0A1}

derive_pg_connection -power_net {VDD} \
  -ground_net {VSS} -power_pin {VDD} -ground_pin {VSS}
derive_pg_connection -tie -power_net VDD -ground_net VSS
derive_pg_connection -power_net VDDBR -power_pin VDDBR
derive_pg_connection -tie -power_net VDDBR
derive_pg_connection -power_net VDDBC -power_pin VDDBC
derive_pg_connection -tie -power_net VDDBC

### top level power rings ###
create_rectangular_rings -around rectangle -nets {VSS VDD VDDBC VDDBR} \
  -within {{190 190} {1528 1528}} \
  -left_segment_width 3.0 \
  -right_segment_width 3.0 -bottom_segment_width 3.0 \
  -top_segment_width 3.0 -left_segment_layer METG1 \
  -right_segment_layer METG1 -bottom_segment_layer METS2 \
  -top_segment_layer METS2
### cube's power rings ###
create_rectangular_rings -around rectangle -nets {VSS VDD} \
  -within {{892.8 655} {1310 1076}} \
  -left_segment_width 3.0 \
  -right_segment_width 3.0 -bottom_segment_width 3.0 \
  -top_segment_width 3.0 -left_segment_layer METG1 \
  -right_segment_layer METG1 -bottom_segment_layer METS2 \
  -top_segment_layer METS2 

### sb4 vertical strap ###
create_power_straps  -direction vertical -start_at 202.5 \
  -num_placement_strap 114 -increment_x_or_y 5.0 -pitch_within_group 5.0 \
  -nets  {VDD VSS} -layer MET5 -width 3.0 -step 6.0
create_power_straps  -direction vertical -start_at 845 \
  -num_placement_strap 1 -increment_x_or_y 5.0 -pitch_within_group 5.0 \
  -nets  {VDD VSS VDD} -layer MET5 -width 3.0 -step 6.0
### ptp0,1 vertical strap ###
create_power_straps  -direction vertical -start_at 912.5 \
  -num_placement_strap 78 -increment_x_or_y 5.0 -pitch_within_group 5.0 \
  -nets  {VDD VSS} -layer MET5 -width 3.0 -step 6.0
create_power_straps  -direction vertical -start_at 1352.5 \
  -num_placement_strap 31 -increment_x_or_y 5.0 -pitch_within_group 5.0 \
  -nets  {VDD VSS} -layer MET5 -width 3.0 -step 6.0
### cube's strap ###
create_power_straps  -direction vertical -start_at 903.6 \
  -num_placement_strap 28 -increment_x_or_y 14.4 -pitch_within_group 0.5 \
  -nets  {VDD VSS} -layer MET6 -width 1.8 -step 1.0 \
  -start_low_ends coordinate  -start_low_ends_coordinate 660.0 \
  -start_high_ends coordinate  -start_high_ends_coordinate 1070.0

### strap horizontal ###
create_power_straps  -direction horizontal -start_at 207.5 \
  -num_placement_strap 88 -increment_x_or_y 5.0 -pitch_within_group 5.0 \
  -nets  {VDD VSS} -layer MET6 -width 3.0 -step 6.0
create_power_straps  -direction horizontal -start_at 652.5 \
  -num_placement_strap 84 -increment_x_or_y 5.0 -pitch_within_group 5.0 \
  -nets  {VDD VSS} -layer MET6 -width 3.0 -step 6.0
create_power_straps  -direction horizontal -start_at 1087.5 \
  -num_placement_strap 85 -increment_x_or_y 5.0 -pitch_within_group 5.0 \
  -nets  {VDD VSS} -layer MET6 -width 3.0 -step 6.0

### strap for VDDBR in sb4 ###
create_power_straps  -direction horizontal -start_at 885.6 -width 1.0 \
  -num_placement_strap 1 -nets  {VDDBR} -layer MET3 
### strap for VDDBC  in sb4 ###
create_power_straps  -direction horizontal -start_at 848.0 -width 1.0 \
  -num_placement_strap 1 -nets  {VDDBC} -layer MET3 
### strap for VDDBR in ptp ###
create_power_straps  -direction vertical -start_at 1227.4 -width 1.0 \
  -num_placement_strap 1 -nets  {VDDBR} -layer MET2 
### strap for VDDBC in ptp ###
create_power_straps  -direction vertical -start_at 1164.2 -width 1.0 \
  -num_placement_strap 1 -nets  {VDDBC} -layer MET2 

### VDD & VSS connect ###
derive_pg_connection -power_net VDD \
  -ground_net VSS -power_pin VDD -ground_pin VSS
derive_pg_connection -power_net VDE -power_pin VDE
derive_pg_connection -tie -power_net VDD -ground_net VSS
derive_pg_connection -power_net VDDBR -power_pin VDDBR
derive_pg_connection -tie -power_net VDDBR
derive_pg_connection -power_net VDDBC -power_pin VDDBC
derive_pg_connection -tie -power_net VDDBC

preroute_instances -ignore_macros -ignore_cover_cells

create_placement_blockage -bbox {197 255 220 1480}
create_placement_blockage -bbox {765 255 791 1480}
create_placement_blockage -bbox {903 1134 920 1509}
create_placement_blockage -bbox {1500 1134 1520 1509}
create_placement_blockage -bbox {903 205 920 580}
create_placement_blockage -bbox {1500 205 1520 580}
create_placement_blockage -bbox {886 648 1310 1082}

add_tap_cell_array -master_cell_name {SC23YUZTAP021} -distance 36.0 \
  -skip_fixed_cells false -no_tap_cell_under_layer {M1 M2} \
  -connect_power_name {VDD} -connect_ground_name {VSS}

derive_pg_connection -power_net VDD \
  -ground_net VSS -power_pin VDD -ground_pin VSS
derive_pg_connection -tie -power_net VDD -ground_net VSS
derive_pg_connection -power_net VDE -power_pin VDE

preroute_standard_cells -connect horizontal \
  -extend_to_boundaries_and_generate_pins -port_filter_mode off \
  -cell_master_filter_mode off -cell_instance_filter_mode off \
  -voltage_area_filter_mode off

source scripts/antenna_rule.tcl
set_parameter -name doAntennaConx -value 4
set_route_options -groute_timing_driven true \
  -droute_stack_via_less_than_min_area forbid -same_net_notch check_and_fix \
  -fat_wire_check merge_then_check
set_ignored_layers -max_routing_layer METG2

### create clock tree ###
#clock_opt
#remove_placement_blockage -all

route_auto
route_search_repair -rerun_drc -trim_antenna_of_user_wires -loop 20
verify_route -antenna
route_search_repair -rerun_drc -trim_antenna_of_user_wires -loop 20
derive_pg_connection -power_net VDD \
        -ground_net VSS -power_pin VDD -ground_pin VSS
insert_stdcell_filler -connect_to_power VDD \
  -connect_to_ground VSS \
  -cell_without_metal {SC23YUZS021 SC23YUZS011} \
  -cell_with_metal {SC23YUZCUBAS081}

derive_pg_connection -power_net VDD \
  -ground_net VSS -power_pin VDD -ground_pin VSS
derive_pg_connection -power_net VDE -power_pin VDE
preroute_standard_cells -mode tie -nets {VDD VSS} \
  -connect horizontal -port_filter_mode off \
  -voltage_area_filter_mode off
optimize_wire_via
derive_pg_connection -power_net VDD \
  -ground_net VSS -power_pin VDD -ground_pin VSS
derive_pg_connection -power_net VDE -power_pin VDE

#
# STOP HERE. PLEASE RUN DRC.
#

set_write_stream_options  -map_layer ./lib/gdsout.map -child_depth 0 \
  -output_pin {text geometry}  -output_design_intent
move_mw_cel_origin -to {858 858} [current_mw_cel]
save_mw_cel -design CUBE_TOP
write -format ddc -hierarchy -output CUBE_TOP_out.ddc
write_verilog -no_physical_only_cells CUBE_TOP_out.v
write_verilog -no_unconnected_cells -pg CUBE_TOP_lvs.v
set_write_stream_options  -map_layer ./lib/gdsout.map -child_depth 0 \
  -output_pin {text geometry}  -output_design_intent
write_stream -format gds -lib_name CUBE_TOP -cells {CUBE_TOP} CUBE_TOP.gds
write_sdf -version 2.1 CUBE_TOP.sdf
