/* $Id: define.h 65 2010-08-07 09:56:11Z matutani $ */
/* 
 * Common 
 */
`define Enable		1'b1
`define Disable		1'b0
`define Enable_		1'b0
`define Disable_	1'b1

/* Packet length (1 head flit, 3 data flits, and 1 tail flit) */
`define PKTLEN		4
`define PKTLEN_P1	5
`define PKTLENW		3
`define PKTLENW_P1	4

/* Flit format (32-bit data + 2-bit type) */
`define DATAW		33
`define DATAW_P1	34
`define DST_LSB         0
`define DST_MSB         3
`define LEN_LSB         4
`define LEN_MSB         7
`define PAD_LSB         8
`define PAD_MSB         31
`define TYPE_LSB	32
`define TYPE_MSB	33

/* Flit type */
`define TYPEW		1
`define TYPEW_P1	2
`define TYPE_NONE	2'b00
`define TYPE_HEAD	2'b01
`define TYPE_DATA	2'b10
`define TYPE_TAIL	2'b11

/* Mode (0: Point-to-point, 1: Sbus) */
`define MODE_P2P	1'b0
`define MODE_SBUS	1'b1

/*
 * Router
 */
/* Input FIFO (16-element) */
`define FIFO            15
`define FIFO_P1         16
`define FIFOD           3
`define FIFOD_P1        4

/* Port number (3-port) */
`define PORT            2
`define PORT_P1         3
`define PORTW           1
`define PORTW_P1        2

/* Vch number (2-VC) */
`define VCH             1
`define VCH_P1          2
`define VCHW            0
`define VCHW_P1         1

/*
 * Core
 */
/* Number of chips (8 chips) */
`define CHIP		7
`define CHIP_P1		8
`define CHIPW		2
`define CHIPW_P1	3

/* Number of cores (16 cores, or 8 chips) */
`define NODE		15
`define NODE_P1		16
`define NODEW		3
`define NODEW_P1	4

/* Packet counter (45 bits) */
`define PKTCNTW		44
`define PKTCNTW_P1	45

/* Event ROM */
`define EROM_INDEX	4095
`define EROM_INDEX_P1	4096
`define EROM_INDEXW	11
`define EROM_INDEXW_P1	12
`define EROM_DST_LSB	0
`define EROM_DST_MSB	3
`define EROM_SRC_LSB	4
`define EROM_SRC_MSB	7
`define EROM_VCH_LSB	8
`define EROM_VCH_MSB	11
`define EROM_CLK_LSB	12
`define EROM_CLK_MSB	43

/*
 * TX/RX
 */
`define TRDATAW		34
`define TRDATAW_P1	35
`define TRSELW		1
`define TRSELW_P1	2
`define TRSEL_TX	2'b01
`define TRSEL_RX	2'b10
`define TRSEL_IDLE	2'b00
