/* $Id: router.v 23 2010-07-23 04:28:03Z matutani $ */
`include "../design/define.h" 
module router ( 
        idata_0,  
        ivalid_0, 
        ivch_0,   
        oack_0,   
        ordy_0,   

        idata_1,  
        ivalid_1, 
        ivch_1,   
        oack_1,   
        ordy_1,   

        idata_2,  
        ivalid_2, 
        ivch_2,   
        oack_2,   
        ordy_2,   

        odata_0,  
        ovalid_0, 
        ovch_0,   
        iack_0,   

        odata_1,  
        ovalid_1, 
        ovch_1,   
        iack_1,   

        odata_2,  
        ovalid_2, 
        ovch_2,   
        iack_2,   

        id, 
	top,
	bottom,

        clk, 
        rst_  
);
parameter       ROUTERID = 0;

input   [`DATAW:0] idata_0;  
input              ivalid_0; 
input   [`VCHW:0]  ivch_0;   
output  [`VCH:0]   oack_0;   
output  [`VCH:0]   ordy_0;   

input   [`DATAW:0] idata_1;  
input              ivalid_1; 
input   [`VCHW:0]  ivch_1;   
output  [`VCH:0]   oack_1;   
output  [`VCH:0]   ordy_1;   

input   [`DATAW:0] idata_2;  
input              ivalid_2; 
input   [`VCHW:0]  ivch_2;   
output  [`VCH:0]   oack_2;   
output  [`VCH:0]   ordy_2;   

output  [`DATAW:0] odata_0;  
output             ovalid_0; 
output  [`VCHW:0]  ovch_0;   
input   [`VCH:0]   iack_0;   

output  [`DATAW:0] odata_1;  
output             ovalid_1; 
output  [`VCHW:0]  ovch_1;   
input   [`VCH:0]   iack_1;   

output  [`DATAW:0] odata_2;  
output             ovalid_2; 
output  [`VCHW:0]  ovch_2;   
input   [`VCH:0]   iack_2;   

input	[`NODEW:0] id;
input		   top;
input		   bottom;

input    clk;  
input    rst_;  

/* 
 * Wires from input channels (ic_) 
 */ 
wire [`DATAW:0] ic_odata_0; 
wire [`DATAW:0] ic_odata_1; 
wire [`DATAW:0] ic_odata_2; 

wire            ic_ovalid_0; 
wire            ic_ovalid_1; 
wire            ic_ovalid_2; 

wire [`VCHW:0]  ic_ovch_0; 
wire [`VCHW:0]  ic_ovch_1; 
wire [`VCHW:0]  ic_ovch_2; 

wire [`PORTW:0] ic_port_0; 
wire [`PORTW:0] ic_port_1; 
wire [`PORTW:0] ic_port_2; 

wire            ic_req_0; 
wire            ic_req_1; 
wire            ic_req_2; 

/* 
 * Wires from crossbar (cb_) 
 */ 
wire [`DATAW:0] cb_odata_0; 
wire [`DATAW:0] cb_odata_1; 
wire [`DATAW:0] cb_odata_2; 

wire            cb_ovalid_0; 
wire            cb_ovalid_1; 
wire            cb_ovalid_2; 

wire [`VCHW:0]  cb_ovch_0; 
wire [`VCHW:0]  cb_ovch_1; 
wire [`VCHW:0]  cb_ovch_2; 

wire [`PORT:0]  cb_grt_0; 
wire [`PORT:0]  cb_grt_1; 
wire [`PORT:0]  cb_grt_2; 

/* 
 * Wires from output channels (oc_) 
 */ 
wire [`VCH:0]   oc_ordy0_0; 
wire [`VCH:0]   oc_ordy0_1; 
wire [`VCH:0]   oc_ordy0_2; 

wire [`VCH:0]   oc_ordy1_0; 
wire [`VCH:0]   oc_ordy1_1; 
wire [`VCH:0]   oc_ordy1_2; 

/* 
 * Input physical channels 
 */ 
inputc #( ROUTERID, 0 ) ic_0 ( 
       .idata  ( idata_0     ), 
       .ivalid ( ivalid_0    ), 
       .ivch   ( ivch_0      ), 
       .oack   ( oack_0      ), 
       .ordy   ( ordy_0      ), 

       .odata  ( ic_odata_0  ), 
       .ovalid ( ic_ovalid_0 ), 
       .ovch   ( ic_ovch_0   ), 

       .irdy0_0( oc_ordy0_0  ), 
       .irdy0_1( oc_ordy0_1  ), 
       .irdy0_2( oc_ordy0_2  ), 
       .irdy1_0( oc_ordy1_0  ), 
       .irdy1_1( oc_ordy1_1  ), 
       .irdy1_2( oc_ordy1_2  ), 

       .grt_0  ( cb_grt_0[0] ), 
       .grt_1  ( cb_grt_0[1] ), 
       .grt_2  ( cb_grt_0[2] ), 

       .port   ( ic_port_0   ), 
       .req    ( ic_req_0    ), 

       .id     ( id          ),  
       .top    ( top         ),  
       .bottom ( bottom      ),  

       .clk    ( clk         ),
       .rst_   ( rst_        )
);                             

inputc #( ROUTERID, 1 ) ic_1 ( 
       .idata ( idata_1     ), 
       .ivalid( ivalid_1    ), 
       .ivch  ( ivch_1      ), 
       .oack  ( oack_1      ), 
       .ordy  ( ordy_1      ), 

       .odata ( ic_odata_1  ), 
       .ovalid( ic_ovalid_1 ), 
       .ovch  ( ic_ovch_1   ), 

       .irdy0_0( oc_ordy0_0  ), 
       .irdy0_1( oc_ordy0_1  ), 
       .irdy0_2( oc_ordy0_2  ), 
       .irdy1_0( oc_ordy1_0  ), 
       .irdy1_1( oc_ordy1_1  ), 
       .irdy1_2( oc_ordy1_2  ), 

       .grt_0 ( cb_grt_1[0] ), 
       .grt_1 ( cb_grt_1[1] ), 
       .grt_2 ( cb_grt_1[2] ), 

       .port  ( ic_port_1   ), 
       .req   ( ic_req_1    ), 

       .id    ( id          ),  
       .top   ( top         ),  
       .bottom( bottom      ),  

       .clk   ( clk         ),
       .rst_  ( rst_        )
);                             

inputc #( ROUTERID, 2 ) ic_2 ( 
       .idata ( idata_2     ), 
       .ivalid( ivalid_2    ), 
       .ivch  ( ivch_2      ), 
       .oack  ( oack_2      ), 
       .ordy  ( ordy_2      ), 

       .odata ( ic_odata_2  ), 
       .ovalid( ic_ovalid_2 ), 
       .ovch  ( ic_ovch_2   ), 

       .irdy0_0( oc_ordy0_0  ), 
       .irdy0_1( oc_ordy0_1  ), 
       .irdy0_2( oc_ordy0_2  ), 
       .irdy1_0( oc_ordy1_0  ), 
       .irdy1_1( oc_ordy1_1  ), 
       .irdy1_2( oc_ordy1_2  ), 

       .grt_0 ( cb_grt_2[0] ), 
       .grt_1 ( cb_grt_2[1] ), 
       .grt_2 ( cb_grt_2[2] ), 

       .port  ( ic_port_2   ), 
       .req   ( ic_req_2    ), 

       .id    ( id          ),  
       .top   ( top         ),  
       .bottom( bottom      ),  

       .clk   ( clk         ),
       .rst_  ( rst_        )
);                             

/* 
 * Crossbar switch 
 */ 
cb cb ( 
        .idata_0 ( ic_odata_0  ), 
        .ivalid_0( ic_ovalid_0 ), 
        .ivch_0  ( ic_ovch_0   ), 
        .port_0  ( ic_port_0   ), 
        .req_0   ( ic_req_0    ), 
        .grt_0   ( cb_grt_0    ), 

        .idata_1 ( ic_odata_1  ), 
        .ivalid_1( ic_ovalid_1 ), 
        .ivch_1  ( ic_ovch_1   ), 
        .port_1  ( ic_port_1   ), 
        .req_1   ( ic_req_1    ), 
        .grt_1   ( cb_grt_1    ), 

        .idata_2 ( ic_odata_2  ), 
        .ivalid_2( ic_ovalid_2 ), 
        .ivch_2  ( ic_ovch_2   ), 
        .port_2  ( ic_port_2   ), 
        .req_2   ( ic_req_2    ), 
        .grt_2   ( cb_grt_2    ), 

        .odata_0 ( cb_odata_0  ), 
        .ovalid_0( cb_ovalid_0 ), 
        .ovch_0  ( cb_ovch_0   ), 

        .odata_1 ( cb_odata_1  ), 
        .ovalid_1( cb_ovalid_1 ), 
        .ovch_1  ( cb_ovch_1   ), 

        .odata_2 ( cb_odata_2  ), 
        .ovalid_2( cb_ovalid_2 ), 
        .ovch_2  ( cb_ovch_2   ), 

        .clk     ( clk         ), 
        .rst_    ( rst_        )
);                   

/* 
 * Output channels 
 */ 
outputc #( ROUTERID, 0 ) oc_0 ( 
       .idata ( cb_odata_0  ), 
       .ivalid( cb_ovalid_0 ), 
       .ivch  ( cb_ovch_0   ), 

       .odata ( odata_0     ), 
       .ovalid( ovalid_0    ), 
       .ovch  ( ovch_0      ), 

       .iack  ( iack_0      ), 
       .ordy0 ( oc_ordy0_0  ), 
       .ordy1 ( oc_ordy1_0  ), 

       .clk   ( clk         ),
       .rst_  ( rst_        )
);                  

outputc #( ROUTERID, 1 ) oc_1 ( 
       .idata ( cb_odata_1  ), 
       .ivalid( cb_ovalid_1 ), 
       .ivch  ( cb_ovch_1   ), 

       .odata ( odata_1     ), 
       .ovalid( ovalid_1    ), 
       .ovch  ( ovch_1      ), 

       .iack  ( iack_1      ), 
       .ordy0 ( oc_ordy0_1  ), 
       .ordy1 ( oc_ordy1_1  ), 

       .clk   ( clk         ), 
       .rst_  ( rst_        )
);                  

outputc #( ROUTERID, 2 ) oc_2 ( 
       .idata ( cb_odata_2  ), 
       .ivalid( cb_ovalid_2 ), 
       .ivch  ( cb_ovch_2   ), 

       .odata ( odata_2     ), 
       .ovalid( ovalid_2    ), 
       .ovch  ( ovch_2      ), 

       .iack  ( iack_2      ), 
       .ordy0 ( oc_ordy0_2  ), 
       .ordy1 ( oc_ordy1_2  ), 

       .clk   ( clk         ),
       .rst_  ( rst_        )
);                  

endmodule
