/* $Id: rtcomp.v 105 2010-08-12 09:00:48Z matutani $ */
`include "../design/define.h" 
module rtcomp (
	addr,
	port,
        ovch,
	
	id,
	top,
	bottom

//	clk,
//	rst_
);
parameter       ROUTERID= 0;
parameter       PCHID   = 0;
parameter	VCHID    = 0;

input	[`NODEW:0] 	addr;
output	[`PORTW:0] 	port;
output	[`VCHW:0] 	ovch;

input	[`NODEW:0]	id;
input			top;
input			bottom;

//input	clk;
//input	rst_;

wire	[`PORTW:0] 	port_0;
wire	[`PORTW:0] 	port_1;

/*
 * Port assignment
 *     0: local core
 *     1: horizontal router
 *     2: vertical router
 */

/*
 * Message class 0 (VC 0) cannot use the horizontal link
 * Message class 1 (VC 1) can    use the horizontal link
 */
assign	port	= (VCHID == 0) ? port_0 : port_1;
assign	port_0	= (addr == id) ? `NODEW_P1'd0 :		/* To local core */
		  (top    &&  id[0]) ? `NODEW_P1'd1 :	/* To horizontal */
		  (bottom && ~id[0]) ? `NODEW_P1'd1 :	/* To horizontal */
		  `NODEW_P1'd2;				/* To vertical   */
assign	port_1	= (addr == id) ? `NODEW_P1'd0 : 	/* To local core */
		  (addr[`NODEW:1] == id[`NODEW:1]) ? `NODEW_P1'd1 :
		  (top    &&  id[0]) ? `NODEW_P1'd1 :	/* To horizontal */
		  (bottom && ~id[0]) ? `NODEW_P1'd1 :	/* To horizontal */
		  `NODEW_P1'd2;				/* To vertical   */

assign	ovch	= VCHID;

endmodule

