###################################################################
# $Id: cube.tcl 117 2010-08-14 02:14:34Z matutani $
###################################################################
lappend serach_path ./
source scripts/set_sz.tcl
set mw_logic0_net VSS
set mw_logic1_net VDD
define_name_rules verilog -allowed "A-Z0-9_"

set_write_stream_options  -map_layer ./lib/gdsout.map -child_depth 0 \
-output_pin {text geometry}  -output_design_intent

create_mw_lib cube -technology lib/tech.tf -mw_reference_library "CS202SZ CS202IO" -open
# open_mw_lib cube 
import_designs ./cube.vnet -format verilog -top cube
set_tlu_plus_files -max_tluplus ./lib/tlu_plus_mfe.worst \
  -min_tluplus ./lib/tlu_plus_mfe.best \
  -tech2itf_map ./lib/layer.map
derive_pg_connection -power_net {VDD} \
  -ground_net {VSS} -power_pin {VDD} -ground_pin {VSS}
derive_pg_connection -tie -power_net VDD -ground_net VSS
read_sdc ./cube.sdc
read_io_constraints ./scripts/cube.tdf
# read_pin_pad_physical_constraints ./scripts/cube.tdf

initialize_floorplan -control_type width_and_height -core_width 400 \
  -core_height 400 -start_first_row -bottom_io2core 0.9 -top_io2core 0.9 \
  -left_io2core 0.9 -right_io2core 0.9

create_power_straps  -direction vertical -start_at 3.6 -num_placement_strap 27 \
  -increment_x_or_y 14.4 -nets  {VDD VSS} -layer MET6 -width 1.8 -step 14.4 \
  -extend_low_ends force_to_boundary_and_generate_pins \
  -extend_high_ends force_to_boundary_and_generate_pins

add_tap_cell_array -master_cell_name {SC23YUZTAP021} -distance 36.0 \
  -skip_fixed_cells false -no_tap_cell_under_layer {M1 M2} \
  -left_macro_blockage_extra_tap must_insert \
  -right_macro_blockage_extra_tap must_insert \
  -left_boundary_extra_tap must_insert \
  -right_boundary_extra_tap must_insert \
  -connect_power_name {VDD} -connect_ground_name {VSS}
source ./scripts/yuzcuba.tcl
create_placement -congestion -congestion_effort high
legalize_placement
place_opt
derive_pg_connection -power_net VDD \
  -ground_net VSS -power_pin VDD -ground_pin VSS
derive_pg_connection -tie -power_net VDD \
  -ground_net VSS
preroute_standard_cells -connect horizontal \
  -extend_to_boundaries_and_generate_pins -port_filter_mode off \
  -cell_master_filter_mode off -cell_instance_filter_mode off \
  -voltage_area_filter_mode off
set_route_options -groute_timing_driven true \
  -droute_stack_via_less_than_min_area forbid \
  -same_net_notch check_and_fix \
  -fat_wire_check merge_then_check
set_ignored_layers -max_routing_layer METG2
source scripts/antenna_rule.tcl
set_parameter -name doAntennaConx -value 4
clock_opt
route_auto
route_search_repair -rerun_drc -trim_antenna_of_user_wires -loop 10
verify_route -antenna
derive_pg_connection -power_net VDD \
  -ground_net VSS -power_pin VDD -ground_pin VSS
insert_stdcell_filler -connect_to_power VDD \
  -connect_to_ground VSS \
  -cell_without_metal {SC23YUZS021 SC23YUZS011} \
  -cell_with_metal {SC23YUZCUBAS081}
derive_pg_connection -power_net VDD \
  -ground_net VSS -power_pin VDD -ground_pin VSS
preroute_standard_cells -mode tie -nets {VDD VSS} \
  -connect horizontal -port_filter_mode off \
  -cell_master_filter_mode off -cell_instance_filter_mode off \
  -voltage_area_filter_mode off
optimize_wire_via
save_mw_cel -design cube
define_name_rules verilog -allowed "A-Z0-9_"
change_names -rules verilog -hierarchy
write -format ddc -hierarchy -output cube_out.ddc
write_verilog -no_physical_only_cells cube_out.v
write_verilog -no_physical_only_cells -pg cube_lvs.v
set_write_stream_options  -map_layer ./lib/gdsout.map -child_depth 0 \
  -output_pin {text geometry}  -output_design_intent
write_stream -format gds -lib_name cube -cells {cube} cube.gds
write_sdf -version 2.1 cube.sdf
report_port -physical > port.loc
create_macro_fram \
  -treat_all_blockage_as_thin_wire -library_name {cube} \
  -cell_name {cube}
extract_hier_antenna_property -cell_name {cube}
