#!/usr/bin/perl
################################################################
# $Id: rom.pl 60 2010-08-01 21:15:03Z matutani $
# Event ROM generator
#
# Usage
#     ./rom.pl > event.hex
#
# NoC mode 
#	0: Point-to-point (single injection)
#	1: Sbus (single injection)
#	2: Point-to-point (burst injection)
#	3: Sbus (burst injection)
################################################################

# NoC mode (0...3)
$mode = 0;

# Maximum packet number is 4093 (not 4094!!)
$num = 4093;

# Number of cores
$core = 8;

# Virtual channel to be used
$vch = 0;

################################################################
# 1. NoC mode
################################################################
printf("// Mode (0:Point-to-point, 1:Sbus, 2:Point-to-point(burst), 3:Sbus(burst))\n");
printf("%x\n", $mode);

################################################################
# 2. Number of events
################################################################
printf("// Number of events \n");
if ($mode == 0) {
	printf("%x\n", $num);
} elsif ($mode == 1) {
	printf("%x\n", $num);
} elsif ($mode == 2) {
	printf("%x\n", 8);
} elsif ($mode == 3) {
	printf("%x\n", 4);
}

################################################################
# 3. Events
################################################################
printf("// { clock[43:12] , vch[11:8] , src[7:4] , dst[3:0] } \n");
if ($mode == 0) {
	for ($i = 0; $i < $num; $i++) {
		$src = int(rand($core));
		$dst = int(rand($core));
		while ($src == $dst) {
			$src = int(rand($core));
			$dst = int(rand($core));
			# $vch = int(rand(2));
		}
		printf("00000010_%x_%x_%x\n", $vch, $src, $dst);
	}
}
elsif ($mode == 1) {
	for ($i = 0; $i < $num; $i++) {
		$src = int(rand($core/2));
		$dst = int(rand($core/2));
		while ($src == $dst) {
			$src = int(rand($core/2));
			$dst = int(rand($core/2));
			$vch = 0;
		}
		printf("00000010_%x_%x_%x\n", $vch, $src * 2, $dst * 2);
	}
}
elsif ($mode == 2) {
	printf("00000010_0_0_1\n");
	printf("00000010_0_1_3\n");
	printf("00000010_0_3_5\n");
	printf("00000010_0_5_7\n");
	printf("00000010_0_7_6\n");
	printf("00000010_0_6_4\n");
	printf("00000010_0_4_2\n");
	printf("00000010_0_2_0\n");
}
elsif ($mode == 3) {
	printf("00000010_0_0_2\n");
	printf("00000010_0_2_4\n");
	printf("00000010_0_4_6\n");
	printf("00000010_0_6_0\n");
}
################################################################
