###################################################################
# $Id: convert_sdf.tcl 101 2010-08-12 03:21:47Z matutani $
###################################################################

#
# Suppress warning messages
#
set suppress_errors { OPT-171 EQN-10 UID-401 CMD-041 DDB-72 DDB-74 SEL-005 }

#
# File names
#
set TOP_MODULE 	"cube"
set DDC_FILE	"../pr/cube_out.ddc"
set SDF_FILE	"cube_pt.sdf"

###################################################################
#
# Library setup
#
###################################################################

#
# Library directory
#
set LIB_DIR "/home/vdec/lib/fujitsu65/cs202_sc_io_lib/db"
set search_path  [concat "." $LIB_DIR $search_path]
set link_path "*"

#
# Libraries
#
set std_max_libs { cs202sz_uc_aob_f_m40_13v.db cs202sz_uc_core_f_m40_13v.db cs202sz_uc_dscan_f_m40_13v.db cs202sz_uc_eco_f_m40_13v.db cs202sz_uc_iso_f_m40_13v.db cs202sz_uc_nscan_f_m40_13v.db cs202sz_uc_scan_f_m40_13v.db }
set std_typ_libs { cs202sz_uc_aob_t_p25_12v.db cs202sz_uc_core_t_p25_12v.db cs202sz_uc_dscan_t_p25_12v.db cs202sz_uc_eco_t_p25_12v.db cs202sz_uc_iso_t_p25_12v.db cs202sz_uc_nscan_t_p25_12v.db cs202sz_uc_scan_t_p25_12v.db }
set std_min_libs { cs202sz_uc_aob_s_p125_105v.db cs202sz_uc_core_s_p125_105v.db cs202sz_uc_dscan_s_p125_105v.db cs202sz_uc_eco_s_p125_105v.db cs202sz_uc_iso_s_p125_105v.db cs202sz_uc_nscan_s_p125_105v.db cs202sz_uc_scan_s_p125_105v.db }
# set mem_max_libs { cs202_cc_s_p100_11v.db }
# set mem_typ_libs { cs202_cc_t_p25_12v.db }
# set mem_min_libs { cs202_cc_f_m40_13v.db }
set mem_max_libs { }
set mem_typ_libs { }
set mem_min_libs { }
set iob_min_libs { cs202_io_f_m40_m_13v_36v.db }
set iob_typ_libs { cs202_io_t_p25_m_12v_33v.db }
set iob_max_libs { cs202_io_s_p125_m_105v_30v.db }
set LIB_MAX_FILE [concat $std_max_libs $mem_max_libs $iob_max_libs ]
set LIB_TYP_FILE [concat $std_typ_libs $mem_typ_libs $iob_typ_libs ]
set LIB_MIN_FILE [concat $std_min_libs $mem_min_libs $iob_min_libs ]
set DW_FILE      "dw_foundation.sldb"

#
# Read standard cell library
#
set link_library   [concat $LIB_MAX_FILE $LIB_TYP_FILE $LIB_MIN_FILE $DW_FILE {*} ]
set target_library [concat $LIB_MAX_FILE $LIB_TYP_FILE $LIB_MIN_FILE ]
set symbol_library [concat $LIB_MAX_FILE $LIB_TYP_FILE $LIB_MIN_FILE "EXD.sdb" ]

# set_operating_conditions -max DEFAULT  -max_library cs202sn_uc_core_t_p125_105v  -min DEFAULT  -min_library cs202sn_uc_core_t_m40_13v

###################################################################
#
# Convert SDF
#
###################################################################

#
# Read Design file
#
read_ddc $DDC_FILE
current_design $TOP_MODULE

#
# Write SDF file 
#
write_sdf -no_edge -context verilog -version 3.0 $SDF_FILE

quit
