/* $Id: txrx.v 110 2010-08-13 03:19:12Z matutani $ */
`include "../design/define.h" 
module txrx ( 
	idata,
	odata,

	wireless_idata,
	wireless_odata,

	sel,

        clk, 
        rst_
);
parameter	DELAY = 3.0;	/* Output latency (3nsec)  */

input	[`TRDATAW:0]	idata;
output	[`TRDATAW:0]	odata;

input	[`TRDATAW:0]	wireless_idata;
output	[`TRDATAW:0]	wireless_odata;

input	[`TRSELW:0]	sel;

input			clk;
input			rst_;

reg	[`TRDATAW:0]	wireless_odata_reg;
reg	[`TRDATAW:0]	odata_reg;

assign	wireless_odata	= (sel == `TRSEL_TX) ? wireless_odata_reg : `TRDATAW_P1'hz;
assign	#(DELAY) odata	= (sel == `TRSEL_RX) ? odata_reg          : `TRDATAW_P1'hz;

always @(posedge clk or negedge rst_) begin
	if (!rst_) begin
		wireless_odata_reg	<= 0;
		odata_reg		<= 0;
	end else if (sel == `TRSEL_TX) begin
		wireless_odata_reg	<= idata;
		odata_reg		<= 0;
	end else if (sel == `TRSEL_RX) begin
		wireless_odata_reg	<= 0;
		odata_reg		<= wireless_idata;
	end else begin
		wireless_odata_reg	<= 0;
		odata_reg		<= 0;
	end
end

endmodule
