/* $Id: induct_dummy250.v 89 2010-08-10 11:10:02Z matutani $ */
module sb4 (
	idata0, idata1, idata2, idata3,
	odata0, odata1, odata2, odata3,
	sel0, sel1, sel2, sel3,
	idemux, omux, oosc, ocounter,
	clk, ireset
);
input	[34:0]	idata0, idata1, idata2, idata3;
output	[34:0]	odata0, odata1, odata2, odata3;
input  		idemux;
output 		omux, oosc, ocounter;
input	[1:0]	sel0, sel1, sel2, sel3;
input		clk, ireset;

wire 	[1:0]   sel;
reg 	[34:0] 	buf0, buf1, buf2, buf3;

assign oosc     = idemux ? buf0[0] & buf1[0] : buf2[0] & buf3[0];
assign ocounter = idemux ? buf0[1] & buf1[1] : buf2[1] & buf3[1];
assign omux     = idemux ? buf0[2] & buf1[2] : buf2[2] & buf3[2];
assign odata0   = buf0;
assign odata1   = buf1;
assign odata2   = buf2;
assign odata3   = buf3;
assign sel      = sel0 & sel1 & sel2 & sel3;
always @(posedge clk) begin
	if (ireset) begin
		buf0 <= 0; buf1 <= 0; buf2 <= 0; buf3 <= 0;
	end else if (sel==2'b10) begin
		buf0	<= idata0;	
		buf1	<= idata1;	
		buf2	<= idata2;	
		buf3	<= idata3; 
	end
end
endmodule
