lappend serach_path ./
source scripts/set_sz.tcl
set mw_logic0_net VSS
set mw_logic1_net VDD
define_name_rules verilog -allowed "A-Z0-9_"
set_write_stream_options  -map_layer ./lib/gdsout.map -child_depth 0 \
-output_pin {text geometry}  -output_design_intent

create_mw_lib sb4 -technology lib/tech.tf -mw_reference_library "CS202SZ CS202IO" -open
# open_mw_lib sb4 
import_designs ./sb4.vnet -format verilog -top sb4
set_tlu_plus_files -max_tluplus ./lib/tlu_plus_mfe.worst \
  -min_tluplus ./lib/tlu_plus_mfe.best \
  -tech2itf_map ./lib/layer.map
derive_pg_connection -power_net {VDD} \
  -ground_net {VSS} -power_pin {VDD} -ground_pin {VSS}
derive_pg_connection -tie -power_net VDD -ground_net VSS
derive_pg_connection -power_net {VDDBR} -power_pin {VDDBR}
derive_pg_connection -tie -power_net VDDBR
derive_pg_connection -power_net {VDDBC} -power_pin {VDDBC}
derive_pg_connection -tie -power_net VDDBC
read_sdc ../syn/sb4.sdc
read_io_constraints ./scripts/sb4.tdf

initialize_floorplan -control_type width_and_height -core_width 573.2 \
  -core_height 1223.2 -start_first_row -bottom_io2core 0.9 -top_io2core 0.9 \
  -left_io2core 0.9 -right_io2core 0.9

create_power_straps  -direction vertical -start_at 2.5 \
  -num_placement_strap 115 -increment_x_or_y 10.0 -pitch_within_group 5.0 \
  -nets  {VDD VSS} -layer MET5 -width 3.0 -step 10.0 \
  -extend_low_ends force_to_boundary_and_generate_pins \
  -extend_high_ends force_to_boundary_and_generate_pins
create_power_straps  -direction horizontal -start_at 2.5 \
  -num_placement_strap 245 -increment_x_or_y 10.0 -pitch_within_group 5.0 \
  -nets  {VDD VSS} -layer MET6 -width 3.0 -step 10.0 \
  -extend_low_ends force_to_boundary_and_generate_pins \
  -extend_high_ends force_to_boundary_and_generate_pins
create_power_straps  -direction horizontal -start_at 630.6 \
  -num_placement_strap 1 -nets  {VDDBR} -layer MET3 -width 1.0 \
  -extend_low_ends force_to_boundary_and_generate_pins \
  -extend_high_ends force_to_boundary_and_generate_pins
create_power_straps  -direction horizontal -start_at 593.0 \
  -num_placement_strap 1 -nets  {VDDBC} -layer MET3 -width 1.0 \
  -extend_low_ends force_to_boundary_and_generate_pins \
  -extend_high_ends force_to_boundary_and_generate_pins

derive_pg_connection -power_net {VDDBR} -power_pin {VDDBR}
derive_pg_connection -tie -power_net VDDBR
derive_pg_connection -power_net {VDDBC} -power_pin {VDDBC}
derive_pg_connection -tie -power_net VDDBC

create_placement_blockage -bbox {0 630.1 575 631.1}
create_placement_blockage -bbox {0 592.5 575 593.5}

add_tap_cell_array -master_cell_name {SC23YUZTAP021} -distance 36.0 \
  -skip_fixed_cells false -no_tap_cell_under_layer {M1 M2} \
  -left_macro_blockage_extra_tap must_insert \
  -right_macro_blockage_extra_tap must_insert \
  -left_boundary_extra_tap must_insert \
  -right_boundary_extra_tap must_insert \
  -connect_power_name {VDD} -connect_ground_name {VSS}

place_opt
derive_pg_connection -power_net VDD \
  -ground_net VSS -power_pin VDD -ground_pin VSS
derive_pg_connection -tie -power_net VDD \
  -ground_net VSS
preroute_standard_cells -connect horizontal \
  -extend_to_boundaries_and_generate_pins -port_filter_mode off \
  -cell_master_filter_mode off -cell_instance_filter_mode off \
  -voltage_area_filter_mode off
set_route_options -groute_timing_driven true \
  -droute_stack_via_less_than_min_area forbid \
  -same_net_notch check_and_fix \
  -fat_wire_check merge_then_check
set_ignored_layers -max_routing_layer METG2
source scripts/antenna_rule.tcl
set_parameter -name doAntennaConx -value 4
clock_opt
route_auto
route_search_repair -rerun_drc -trim_antenna_of_user_wires -loop 10
verify_route -antenna
derive_pg_connection -power_net VDD \
  -ground_net VSS -power_pin VDD -ground_pin VSS
# remove_placement_blockage -all

insert_stdcell_filler -connect_to_power VDD \
  -connect_to_ground VSS \
  -cell_without_metal {SC23YUZS021 SC23YUZS011} \
  -cell_with_metal {SC23YUZCUBAS081}

derive_pg_connection -power_net VDD \
  -ground_net VSS -power_pin VDD -ground_pin VSS
preroute_standard_cells -mode tie -nets {VDD VSS} \
  -connect horizontal -port_filter_mode off \
  -cell_master_filter_mode off -cell_instance_filter_mode off \
  -voltage_area_filter_mode off
optimize_wire_via
save_mw_cel -design sb4
create_macro_fram -treat_all_blockage_as_thin_wire -library_name {sb4} \
  -cell_name {sb4}
write -format ddc -hierarchy -output sb4_out.ddc
write_verilog -no_physical_only_cells -pg sb4_lvs.v
write_verilog -pg sb4_lvs_p.v
set_write_stream_options  -map_layer ./lib/gdsout.map -child_depth 0 \
  -output_pin {text geometry}  -output_design_intent
write_stream -format gds -lib_name sb4 -cells {sb4} sb4.gds
